//+------------------------------------------------------------------+
//|                                   Diamond Algorithm Selector.mq4 |
//|                                        Copyright  2009, DASTeam |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, DASTeam"
#property link      ""
extern string eaparams=    "-------------------------------------EA Parameters-------------------------------------------------";
extern int    HHH=10;
extern int    LLL=10;
extern int    Type=0;
extern double StartDeposit=10000;
extern string Symb="USDJPY";//     
int maxorders=1;
extern string optParams=   "-----------------------------------Optimization Parameters------------------------------------";
extern bool   Optimization=true;
extern int    OptimizePeriod=90; //       -TestPeriod ( )   
extern int    TestPeriod=15; //            ( )
//        
extern int    DetailOptimization=1;//      ;     1
extern int    DetailOptimizationDispersion=5;//    
extern string filterParams="-------------------------------------Filter Parameters---------------------------------------------";
extern bool   Filter=false;
extern int    TradesPerSpell = 2; //           
extern double CoincidencePercent = 10; //      TP    , ,  SL
extern double ProfitFactor = 1; //      
extern string EndTestTime = "2009.10.24";
extern double GDD=3;
extern string JournalFileName = "DASJournal";//  .    "/"    -
// -    -    -   3
double totTPOrders[2],totSLOrders[2],totProfit[2],totLoss[2],SL,TP, AvTP,AvSL,maxGDD[2],H,L,A,CurDepo[2];
double LastOptimize;
double Operands[5],Orders[2][4][2];
int nOrders[2],x=1,totOrders;
int oStartHHH,oStartLLL,oStartType,oStartStartDeposit,oStartOptimizPeriod,oStartTestPeriod;
int oShagHHH=15,oShagLLL=15,oShagType=1,oShagStartDeposit=1,oShagOptimizPeriod=15, oShagTestPeriod=15;
int oEndHHH=30,oEndLLL=30,oEndType=1,oEndStartDeposit=10000,oEndOptimizPeriod=90,oEndTestPeriod=15;
bool Over[2],isPrint;
string EndTestTime2[2];

int init()
{if(Digits==3 || Digits==5)x=10;
CurDepo[0]=StartDeposit;
oStartHHH=HHH;
oStartLLL=LLL;
oStartType=Type;
oStartStartDeposit=StartDeposit;
oStartOptimizPeriod=OptimizePeriod;
oStartTestPeriod=TestPeriod;
EndTestTime2[0]=EndTestTime;
}

int start()
{EngineProcedure();
}

bool EngineProcedure(int tradetype=0, string timestring="",double bshift=0)
{//Print(iOpen("USDJPY",1,iBarShift("USDJPY",1,TimeCurrent(),false)));
string timeStr;
if(Bars<=oEndOptimizPeriod*24*60/Period() && Optimization)return;
if(tradetype==0)timeStr="00:00"; else timeStr=timestring;
if(tradetype==0 && Optimization)
  if (!Reoptimize()) PrintErrorLog();
if (Over[tradetype])return; // ..          -    
//Over=ChecForOver();
if (!GetOperands(bshift+1)) PrintErrorLog();
if (!CheckCloseOrModif(tradetype,bshift)) PrintErrorLog();
if (StrToTime(timeStr)>=StrToTime(EndTestTime2[tradetype]))
  {if(!Optimization)
     {if(nOrders[tradetype]==0 || CurDepo[tradetype]<=0)
       {Over[tradetype]=true;
        if(!PrintJournal(tradetype))PrintErrorLog();
        return;
       }
     }
     else
      {Over[tradetype]=true;
       if(!PrintJournal(tradetype))PrintErrorLog();
       return;
      }
   if(nOrders[tradetype]!=0 && !Optimization) return;
  }
if (!CheckOpen(tradetype,bshift)) PrintErrorLog();
}

bool Reoptimize()
{double optParam;double Fi;bool isLineEnd=true;string fStr;
if((TimeCurrent()-LastOptimize)/60/60/24<TestPeriod)return;
LastOptimize=TimeCurrent();
PrintJournal(0);
EndTestTime2[1]=DoubleToStr(TimeYear(Time[1]),0)+"."+DoubleToStr(TimeMonth(Time[1]),0)+"."+DoubleToStr(TimeDay(Time[1]),0);
int handle=FileOpen(JournalFileName+DoubleToStr(1,0)+".csv",FILE_CSV|FILE_WRITE,';');
FileClose(handle);
for(int i=oStartHHH;i<=oEndHHH;i+=oShagHHH)
  for(int j=oStartLLL;j<=oEndLLL;j+=oShagLLL)
    for(int y=oStartType;y<=oEndType;y+=oShagType)
      for(int u=oStartOptimizPeriod;u<=oEndOptimizPeriod;u+=oShagOptimizPeriod)
        for(int g=oStartTestPeriod;g<=oEndTestPeriod;g+=oShagTestPeriod)
          {CurDepo[1]=oStartStartDeposit;
           totTPOrders[1]=0;
           totSLOrders[1]=0;
           totProfit[1]=0;
           totLoss[1]=0;
           maxGDD[1]=0;
           nOrders[1]=0;
           Over[1]=false;
           HHH=i;
           LLL=j;
           Type=y;
           OptimizePeriod=u;
           TestPeriod=g;
           int p=(iTime(NULL,1440,0)-iTime(NULL,1440,u))/60/5+(Time[0]-iTime(NULL,1440,0))/60/5;
           for(p=p;p>=0;p--)
             if(TimeDayOfWeek(Time[p])<6 || TimeDayOfWeek(Time[p])>0) 
                EngineProcedure(1,DoubleToStr(TimeYear(Time[p]),0)+"."+DoubleToStr(TimeMonth(Time[p]),0)+
                "."+DoubleToStr(TimeDay(Time[p]),0),p+1);
           
          }
handle=FileOpen(JournalFileName+DoubleToStr(1,0)+".csv",FILE_CSV|FILE_READ,';');
while(!FileIsEnding(handle))
  {fStr=FileReadString(handle,12);
    if(isLineEnd && StrToDouble(fStr)>optParam) 
      {optParam=StrToDouble(fStr);
       for(int k=1;k<=5;k++) FileReadString(handle,12);
       HHH=StrToDouble(FileReadString(handle,12));
       LLL=StrToDouble(FileReadString(handle,12));
       Type=StrToDouble(FileReadString(handle,12));
       StartDeposit=StrToDouble(FileReadString(handle,12));
       OptimizePeriod=StrToDouble(FileReadString(handle,12));
       TestPeriod=StrToDouble(FileReadString(handle,12));
      }
     isLineEnd=FileIsLineEnding(handle);
  }
Print(HHH,"  ",LLL,"  ",Type,"  ",StartDeposit,"  ",OptimizePeriod,"  ", TestPeriod);
FileClose(handle);
totTPOrders[0]=0;
totSLOrders[0]=0;
totProfit[0]=0;
totLoss[0]=0;
maxGDD[0]=0;
nOrders[1]=0;
Over[0]=false;          
return(true);
}

bool GetOperands(double bshift=1){
H=High[iHighest(Symbol(),5,MODE_HIGH,HHH,bshift)];
L=Low[iLowest(Symbol(),5,MODE_LOW,LLL,bshift)];
return(true);
}

bool GetVars(int tradetype=0,double mDD=0){
double gdd=totProfit[tradetype]-totLoss[tradetype];
if(maxGDD[tradetype]>mDD)maxGDD[tradetype]=mDD;
CurDepo[tradetype]+=gdd;
}

bool PrintJournal(int tradetype=0){double coi3;
double points=NormalizeDouble((totProfit[tradetype]-totLoss[tradetype])/Point/x,0),coi,coi2;
maxGDD[tradetype]=NormalizeDouble((maxGDD[tradetype])/Point/x,0);
string JFN=JournalFileName+DoubleToStr(tradetype,0)+".csv";
if(totTPOrders[tradetype]+totSLOrders[tradetype]==0)coi=100; 
else coi=100-((totSLOrders[tradetype]*100)/(totTPOrders[tradetype]+totSLOrders[tradetype]));
if(totLoss[tradetype]==0)coi2=0; else coi2=totProfit[tradetype]/totLoss[tradetype];
double netprof=NormalizeDouble((10000*(Ask+Point*x)-10000*Ask)*points/iOpen(Symb,1,iBarShift(Symb,1,TimeCurrent())),2);
if(maxGDD[tradetype]==0)coi3=0; else 
coi3=NormalizeDouble(netprof/((10000*(Ask+Point*x)-10000*Ask)*maxGDD[tradetype]/iOpen(Symb,1,iBarShift(Symb,1,TimeCurrent()))),2);
if(Filter)
  {if(coi<CoincidencePercent)return(true);
   if(totTPOrders[tradetype]+totSLOrders[tradetype]<TradesPerSpell)return(true);
   if(coi2<ProfitFactor)return(true);
   if(maxGDD[tradetype]<GDD)return;
  }
int handle;
handle=FileOpen(JFN,FILE_CSV|FILE_READ,';');
if(handle<0)
  {handle=FileOpen(JFN,FILE_CSV|FILE_WRITE,';');
   FileWrite(handle,"  $","  "," ",""," ","  %","HHH",
     "LLL","Type","StartDeposit","OptimizePeriod","TestPeriod");
   FileClose(handle);
  }
else FileClose(handle); 
if(StringSubstr(JFN, 0, 1)=="/") handle=FileOpen(JFN,FILE_CSV|FILE_WRITE,';');
 else handle=FileOpen(JFN,FILE_CSV|FILE_READ|FILE_WRITE,';');
if(handle==-1)return(false);
FileSeek(handle, 0, SEEK_END);
FileWrite(handle,netprof,points,NormalizeDouble(coi2,2),coi3,totTPOrders[tradetype]+totSLOrders[tradetype],
 NormalizeDouble(coi,2),HHH,LLL,Type,StartDeposit,OptimizePeriod,TestPeriod);
FileClose(handle);
return(true);
}

/*bool CheckForOver(){double coi;
if(totTPOrders+totSLOrders==0)coi=100; else coi=100-((totSLOrders*100)/(totTPOrders+totSLOrders));
if(coi<CoincidencePercent)return(true);
return(false);
}*/

bool CheckOpen(int tradetype=0,int bshift=0){bool result=true;
if (Open[bshift]<=L && Type==0) if(Buy (SL,TP,tradetype,bshift)==false) {PrintErrorLog(); result=false;}
if (Open[bshift]>=H && Type==1) if(Sell(SL,TP,tradetype,bshift)==false) {PrintErrorLog(); result=false;}
return(result);
}

bool Buy(double oSL,double oTP,int tradetype=0,int bshift=1){double sl,tp;
if(maxorders==nOrders[tradetype])return(true);
if(oSL!=0)sl=Open[bshift]+Ask-Bid-oSL;
if(oTP!=0)tp=Open[bshift]+Ask-Bid-oTP;
Orders[nOrders[tradetype]][0][tradetype]=Open[bshift]+Ask-Bid;
Orders[nOrders[tradetype]][1][tradetype]=sl;
Orders[nOrders[tradetype]][2][tradetype]=tp;
Orders[nOrders[tradetype]][3][tradetype]=0;
if(isPrint) Print(Orders[nOrders[tradetype]][0][tradetype],"   ",Orders[nOrders[tradetype]][1][tradetype],"   ",
Orders[nOrders[tradetype]][2][tradetype],"   ",Orders[nOrders[tradetype]][3][tradetype]);
nOrders[tradetype]++;
return(true);
}

bool Sell(double oSL,double oTP,int tradetype=0,int bshift=1){double sl,tp;
if(maxorders==nOrders[tradetype])return(true);
if(oSL!=0)sl=Open[bshift]+SL;
if(oTP!=0)tp=Open[bshift]-TP;
Orders[nOrders[tradetype]][0][tradetype]=Open[bshift];
Orders[nOrders[tradetype]][1][tradetype]=sl;
Orders[nOrders[tradetype]][2][tradetype]=tp;
Orders[nOrders[tradetype]][3][tradetype]=1;
if(isPrint) Print(Orders[nOrders[tradetype]][0][tradetype],"   ",Orders[nOrders[tradetype]][1][tradetype],"   ",
Orders[nOrders[tradetype]][2][tradetype],"   ",Orders[nOrders[tradetype]][3][tradetype]);
nOrders[tradetype]++;
return(true);
}

bool CheckCloseOrModif(int tradetype=0,int bshift=0){bool isend;double dd;//Print(tradetype," @$!@%!@");
while (!isend)
{isend=true;
for(int i=0;i<nOrders[tradetype];i++)
 {if(Type==1)
    {dd+=Orders[i][0][tradetype]-Open[bshift]+Ask-Bid;
     if(Open[bshift]<=L)
      {isend=false;
       CloseOrder(i,Orders[i][0][tradetype]-Open[bshift]+Ask-Bid>=0,Open[bshift]+Ask-Bid,tradetype);
       continue;
      }
    }
  if(Type==0)
    {dd+=Open[bshift]-Orders[i][0][tradetype];
     if(Open[bshift]>=H)
       {isend=false;
        CloseOrder(i,Open[bshift]-Orders[i][0][tradetype]>=0,Open[bshift],tradetype);
       }
    }
 }
}
if (!GetVars(tradetype,dd)) PrintErrorLog();
return(true);
}


bool CloseOrder(int OrdPos,bool profit,double price,int tradetype=0){
double p=Orders[OrdPos][0][tradetype]-price;
//DollarProfit=DollarProfit+(10000*(Ask+Point*x)-10000*Ask)*p/iOpen(Symb,1,iBarShift(Symb,1,TimeCurrent()));
if(!profit)
  {totLoss[tradetype]=totLoss[tradetype]+MathAbs(p);
   if(OrdPos<nOrders[tradetype]-1)
     {Orders[OrdPos][0][tradetype]=Orders[nOrders[tradetype]-1][0][tradetype];
      Orders[OrdPos][1][tradetype]=Orders[nOrders[tradetype]-1][1][tradetype];
      Orders[OrdPos][2][tradetype]=Orders[nOrders[tradetype]-1][2][tradetype];
      Orders[OrdPos][3][tradetype]=Orders[nOrders[tradetype]-1][3][tradetype];
      nOrders[tradetype]--;
      totSLOrders[tradetype]++;
      if(isPrint) Print("LOSS ",p);
      return(true);
     }
   totSLOrders[tradetype]++;
   nOrders[tradetype]--;
   if(isPrint) Print("LOSS ",p);
   return(true);
  }
if(profit)
  {totProfit[tradetype]=totProfit[tradetype]+MathAbs(p);
   if(OrdPos<nOrders[tradetype]-1)
     {Orders[OrdPos][0][tradetype]=Orders[nOrders[tradetype]-1][0][tradetype];
      Orders[OrdPos][1][tradetype]=Orders[nOrders[tradetype]-1][1][tradetype];
      Orders[OrdPos][2][tradetype]=Orders[nOrders[tradetype]-1][2][tradetype];
      Orders[OrdPos][3][tradetype]=Orders[nOrders[tradetype]-1][3][tradetype];
      nOrders[tradetype]--;
      totTPOrders[tradetype]++;
      if(isPrint) Print("PROFIT ",p);
      return(true);
     }
   totTPOrders[tradetype]++;
   nOrders[tradetype]--;
   if(isPrint) Print("PROFIT ",p);
  }
}

int PrintErrorLog(){
return(true);
}

